package com.gic.haoban.manage.service.task;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.binlog.base.entity.GicRecord;
import com.gic.clerk.api.dto.ClerkListDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.communicate.api.dto.SyncJsonColumnDTO;
import com.gic.haoban.communicate.api.dto.SyncJsonDTO;
import com.gic.haoban.contacts.api.dto.EmployeeClerkAddDTO;
import com.gic.haoban.contacts.api.service.EmployeeClerkService;
import com.gic.haoban.contacts.manage.api.dto.DepartmentStoreGroupDTO;
import com.gic.haoban.contacts.manage.api.service.DepartmentStoreGroupService;
import com.gic.haoban.contacts.manage.api.service.StoreService;
import com.gic.haoban.manage.api.service.StaffApiService;
import org.apache.commons.lang3.StringUtils;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.listener.MessageListener;

import java.util.ArrayList;
import java.util.List;

/**
 * Created 2019/4/10.
 *
 * @author hua
 */
public class KafkaMessageServiceImpl implements MessageListener<String, GicRecord> {

    private final static Logger logger = LoggerFactory.getLogger(KafkaMessageServiceImpl.class);

    private  final String STORE = "tab_gic_store";

    private final  String CLERK = "tab_gic_clerk";
    
    private final String DEPARTMENT = "tab_gic_store_group";
    
    private final String STORE_IMAGE = "tab_gic_store_photo";
    
    @Autowired
    private StoreService storeService;

    @Autowired
	private ClerkService clerkService;
    
    @Autowired
    private StaffApiService staffApiService;

    @Override
    public void onMessage(ConsumerRecord<String, GicRecord> record) {
        logger.info("message：{}", JSONObject.toJSONString(record.value()));
        String message = JSONObject.toJSONString(record.value());
        if(StringUtils.isBlank(message)){
            return;
        }
//        SyncJsonDTO syncJsonDTO = JSON.toJavaObject((JSONObject)JSON.parse(message),SyncJsonDTO.class);
//        String fieldListString = syncJsonDTO.getFieldList();
//        String tableName = syncJsonDTO.getTableName();
        if(tableName.equals(STORE)){
        	logger.info("【同步门店】");
        	String haobanClerkListString = setClerkList(fieldListString);
        	logger.info("【同步门店】haobanClerkListString={}",haobanClerkListString);
            storeService.syncGicStore(fieldListString,haobanClerkListString);
            
        }else if (tableName.equals(CLERK)){
        	logger.info("【同步店员】");
        	try {
        		employeeClerkService.syncGicClerk(fieldListString);
			} catch (Exception e) {
				logger.info("【同步店员】同步失败={}",e.toString());
			}
        	
        	staffApiService.syncGicClerk(fieldListString);
        }
    }


}
